import sys
import os
from itertools import combinations
from scipy.misc import comb as nChooseK
import numpy as np 
from collections import defaultdict

def compute_mutual_information(stats_str):
    D = np.zeros((2,2))
    stats_str = stats_str.split()
    D[0,0] = float(stats_str[0])
    D[0,1] = float(stats_str[4])
    D[1,0] = float(stats_str[8])
    D[1,1] = float(stats_str[12])
    D /= D.sum()
    return D[1,1] / (D[1,:].sum()*D[:,1].sum())


def extract_variables(iden_str):
    return tuple([int(v) for v in iden_str.split() if not v == '-1'])

try:
    network = sys.argv[1]
    threshold = int(sys.argv[2])
    N = int(sys.argv[3])
    seed = int(sys.argv[4])
    pairs_schedule = sys.argv[5]
    out_schedule = sys.argv[6]
except:
    print "usage write_schedule.py name numvars order"
    sys.exit()


#read in sufficient statistics
statsfile = file(network+'/samples/sufficientStatistics_n'+str(N)+'_s'+str(seed)+'_'+pairs_schedule)
idfile = file(network+'/samples/id_n'+str(N)+'_s'+str(seed)+'_'+pairs_schedule)

numvars = int(statsfile.readline())

statistics = []
counter = 0
while 1:
    iden = idfile.readline()
    stats = statsfile.readline()
    if iden == '':
        break

    if iden.count('-1') == 2: #reading pairs data 
        mi = compute_mutual_information(stats)
        v = extract_variables(iden)
        if mi > 10:
            counter += 1
        statistics.append((v,mi))

print counter
statistics = filter(lambda s: not np.isnan(s[1]), statistics)
statistics.sort(key=lambda s: s[1], reverse=True)
#truncating pairs list
statistics = statistics[:threshold]
print statistics

acceptable_pairs, mutual_informations = zip(*statistics)
siblings = defaultdict(set)
for a,b in acceptable_pairs:
    siblings[a].add(b)
    siblings[b].add(a)

cliques = []

for a in xrange(numvars):
    cliques.append((a,-1,-1,-1))

for a,b in combinations(xrange(numvars), 2):
    cliques.append((min(a,b),max(a,b),-1,-1))

for a in siblings.keys():
    for b in [b for b in siblings[a] if b>a]:
        for c in [c for c in siblings[a] & siblings[b] if c > b]:
            cliques.append((a,b,c,-1))
            for d in [d for d in siblings[a] & siblings[b] & siblings[c] if d > c]:
                cliques.append((a,b,c,d))

out = file(network+'/true_params/'+out_schedule, 'w')
cliques.sort()
print >>out, len(cliques)
for c in cliques:
    for v in c:
        print >>out, v,
    print>>out,""
