import sys
import numpy as np


class Model:
	def __init__(self, p, f, n):
		self.priors = p
		self.failures = f
		self.noise = n

		self.L = len(self.priors)
		self.C = len(self.noise)

	def draw(self):
		samples = [int(np.random.rand() > self.noise[j]) for j in xrange(self.C)]
		for i in xrange(self.L):
			if np.random.rand() > self.priors[i]:
				for j in xrange(self.C):
					if np.random.rand() > self.failures[i][j]:
						samples[j] = 1
		return samples

try:
	N = int(sys.argv[1])
	C = int(sys.argv[2])
	L = int(sys.argv[3])
	sparsity = float(sys.argv[4])
	true_model = file(sys.argv[5], 'w')
	out = file(sys.argv[6], 'w')

except:
	print "usage: generate_data.py numSamples numVariables numLatent sparsity true_model out"
	sys.exit()

p = [np.random.rand()*0.6 + 0.2 for _ in xrange(L)]
n = [0.99 for _ in xrange(C)]
failures = []
for l in xrange(L):
	f = [1 if np.random.rand() < sparsity else np.random.rand()*0.6+0.2 for _ in xrange(C)]
	failures.append(f)

names = ['obs_'+str(i) for i in xrange(C)]
model = Model(p=p, f=failures, n=n)

print >>true_model, 'p', p
print >>true_model, 'f', failures
print >>true_model, 'n', n

print >>out, " ".join(names)
for _ in xrange(N):
	sample = model.draw()
	for s in sample:
		print >>out, s,
	print >>out, ""