
# main.py 
# main structure learning script

import Structure_learner
import cPickle as pickle
from Distribution import Distribution
import numpy as np
import sys
import time
import os


if len(sys.argv) < 6:
    print "usage: python main.py network schedule seed numSamples eigenThresh coupledThresh"
    sys.exit()

network_name = sys.argv[1]

schedule = sys.argv[2]
seed = int(sys.argv[3]) 

try:
    num_samples = int(sys.argv[4])
except:
    num_samples = sys.argv[4]

overwrite = True


#thresholds
#good settings for .25 prior and .9 failures in image experiments
#eigen thresh = 0.003
#epsilon_threshold = 0.1
eigen_threshold = float(sys.argv[5]) # 0.003
epsilon_coupled = float(sys.argv[6]) # 0.1
npairs = int(sys.argv[7])

f_min = 0.01
f_max = 0.99
p_min = 0.01
p_max = 0.49

numProcs=16 #number of processes used to learn structure

thresholds = (eigen_threshold,
              epsilon_coupled,
              f_min, f_max, p_min, p_max)

iden = 'eig'+str(eigen_threshold)
iden += '_coup'+str(epsilon_coupled)

print "solving", network_name
try:
    checkpoint_prefix = network_name+"/checkpoints/"+str(num_samples)+"/"
    os.makedirs(checkpoint_prefix)
except:
    pass

try:
    os.makedirs(network_name+"/learned_params/"+str(num_samples)+'/'+iden)
except:
    print "warning, overwriting results"
    if overwrite == False:
        print "ovewrite is set to false"
        sys.exit()

results_dir = network_name+"/learned_params/"+str(num_samples)+'/'+iden+'/'


#blacklist is used if there are certain variables that should not be included in singly
#coupled quartets.
try:
    blacklist = [int(z.strip()) for z in file(network_name+"/blacklist.txt").readlines()]
except:
    blacklist = None


print "initializing distribution"
distribution = Distribution(network_name, 
                                schedule=schedule,
                                samples=num_samples, 
                                seed=seed, 
                                prune_pairs=False, 
                                checkpoint_prefix=checkpoint_prefix, 
                                blacklist=blacklist,
                                npairs=npairs #only allow the top 1000 pairs 
                            )

children_iden = range(distribution.numChildren)

SL = Structure_learner.Structure_Learner(children_iden, distribution, network_name, checkpoint_prefix, results_dir)
SL.parallel_learn_structure(thresholds, numProcs=numProcs, max_rounds=2)
#SL.writeLayer(-1, outfile=sys.stdout) #print the learned sources to stdout

