#!/bin/bash

set -v

#start by initializing the images network
#make a directory for networks
mkdir networks

#initialize the images network
python generate_synth_images.py networks/images

#compile sampling code
cd sampling
make
cd -

#sample 10000 samples from the images network
./sampling/sample_ss networks/images schedule.txt 0 10000

#learn the structure of the network using these samples
python main.py networks/images/ schedule.txt 0 10000 0.01 0.1 1000

#visualize the learned network
python visualize_images.py networks/images 0.01 0.1
