# visualize_images.py
# a script to visualize learned structure in the synthetic images dataset

import sys
import numpy as np
import matplotlib.pyplot as plt
import os
from collections import defaultdict
import matplotlib as mpl

mpl.rcParams['font.size'] = 20


sources = defaultdict(list)
sample_sizes = os.walk(sys.argv[1]+'/learned_params').next()[1]

network = sys.argv[1]
eig = sys.argv[2]
coup = sys.argv[3]

sample_sizes = sorted(sample_sizes, key=lambda N: float(N))
for N in sample_sizes:
    print N
    layer = 0
    while 1:
        try:
            path = sys.argv[1]+'/learned_params/'+N+'/eig'+eig+'_coup'+coup+'/layer_'+str(layer)
            print path
            infile = file(path)
        except:
            print "no more layers"
            break
    
        for i, l in enumerate(infile):
            prior = float(l.split(':')[0])
            weights = [float(w) for w in l.split(':')[1].split('#')[0].split()]
            quartet = [int(q) for q in l.split('#')[1].split()]
            sources[N].append(np.array(weights).reshape(8,8))
        layer += 1
        
width = 10*max([len(sources[N]) for N in sources.keys()])
height = 10*len(sources.keys())

im = np.zeros((height,width))
print im
for i,N in enumerate(sample_sizes):
    for j,S in enumerate(sources[N]):
        print im[i*9:(i*9+8),j*9:(j*9+8)]
        print 1-S
        im[i*9:(i*9+8),j*9:(j*9+8)] = (1-S)

plt.imshow(im, interpolation="nearest", cmap=plt.cm.Greys_r)
plt.yticks([i*9+4 for i in xrange(len(sample_sizes))], sample_sizes)
plt.xticks(
    [i*9+4 for i in xrange(max([len(sources[N]) for N in sources.keys()]))], 
    [i for i in xrange(max([len(sources[N]) for N in sources.keys()]))]
    )
plt.xlabel('Sources')
plt.ylabel('Sample Size')
#plt.title("Sample size demo")
plt.show()




