# visualize_network.py
# a script to visualize learned structure in the synthetic images dataset

import sys
import numpy as np
import matplotlib.pyplot as plt
import os
from collections import defaultdict
import matplotlib as mpl
import networkx as nx

mpl.rcParams['font.size'] = 20

network = sys.argv[1]
eig = sys.argv[2]
coup = sys.argv[3]
sample_size = sys.argv[4]
dotfile = sys.argv[5]
names = file(network+'/true_params/names.txt').readline().split()

sources = []

model = network+'/learned_params/'+sample_size+'/'+'eig'+eig+'_'+'coup'+coup

layer = 0
while 1:
    try:
        path = model+'/layer_'+str(layer)
        infile = file(path)
    except:
        print "no more layers"
        break

    for i, l in enumerate(infile):
        prior = float(l.split(':')[0])
        weights = [float(w) for w in l.split(':')[1].split('#')[0].split()]
        quartet = [int(q) for q in l.split('#')[1].split()]
        sources.append(weights)
    layer += 1

print names
graph = nx.DiGraph()
for i, source in enumerate(sources):
    for j,val in enumerate(source):
        if val < 1:
            graph.add_edge('src_'+str(i), names[j])

nx.write_dot(graph, dotfile)



